/// <reference types="node" />
import http = require("http");
import * as io_ts from "io-ts";
export declare const PartitionIO: io_ts.InterfaceType<{
    path: io_ts.StringType;
    target: io_ts.StringType;
}, io_ts.TypeOfProps<{
    path: io_ts.StringType;
    target: io_ts.StringType;
}>, io_ts.OutputOfProps<{
    path: io_ts.StringType;
    target: io_ts.StringType;
}>, io_ts.mixed>;
export declare const RofreshConfigIO: io_ts.IntersectionType<[io_ts.InterfaceType<{
    name: io_ts.StringType;
}, io_ts.TypeOfProps<{
    name: io_ts.StringType;
}>, io_ts.OutputOfProps<{
    name: io_ts.StringType;
}>, io_ts.mixed>, io_ts.PartialType<{
    allowAnyPlaceId: io_ts.BooleanType;
    partitions: io_ts.DictionaryType<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>, io_ts.TypeOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.OutputOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.mixed>;
    placeIds: io_ts.ArrayType<io_ts.NumberType, number[], number[], io_ts.mixed>;
}, io_ts.TypeOfPartialProps<{
    allowAnyPlaceId: io_ts.BooleanType;
    partitions: io_ts.DictionaryType<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>, io_ts.TypeOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.OutputOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.mixed>;
    placeIds: io_ts.ArrayType<io_ts.NumberType, number[], number[], io_ts.mixed>;
}>, io_ts.OutputOfPartialProps<{
    allowAnyPlaceId: io_ts.BooleanType;
    partitions: io_ts.DictionaryType<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>, io_ts.TypeOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.OutputOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.mixed>;
    placeIds: io_ts.ArrayType<io_ts.NumberType, number[], number[], io_ts.mixed>;
}>, io_ts.mixed>], io_ts.TypeOfProps<{
    name: io_ts.StringType;
}> & io_ts.TypeOfPartialProps<{
    allowAnyPlaceId: io_ts.BooleanType;
    partitions: io_ts.DictionaryType<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>, io_ts.TypeOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.OutputOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.mixed>;
    placeIds: io_ts.ArrayType<io_ts.NumberType, number[], number[], io_ts.mixed>;
}>, io_ts.OutputOfProps<{
    name: io_ts.StringType;
}> & io_ts.OutputOfPartialProps<{
    allowAnyPlaceId: io_ts.BooleanType;
    partitions: io_ts.DictionaryType<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>, io_ts.TypeOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.OutputOfDictionary<io_ts.StringType, io_ts.InterfaceType<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }, io_ts.TypeOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.OutputOfProps<{
        path: io_ts.StringType;
        target: io_ts.StringType;
    }>, io_ts.mixed>>, io_ts.mixed>;
    placeIds: io_ts.ArrayType<io_ts.NumberType, number[], number[], io_ts.mixed>;
}>, io_ts.mixed>;
export declare type RofreshConfig = io_ts.TypeOf<typeof RofreshConfigIO>;
export declare type RouteCallback = (req: http.IncomingMessage, res: http.ServerResponse) => void;
export interface Route {
    readonly glob: string;
    readonly callback: RouteCallback;
    readonly method: string;
}
export interface Update {
    path: Array<string>;
    type: string;
}
export interface Change extends Update {
    source: string;
}
export interface Remove extends Update {
    source: null;
}
export interface ClientPayload {
    projectName?: string;
    changes?: Array<Change>;
}
export interface ProjectPayload {
    projectName: string;
    changes?: Array<Change | Remove>;
    tagOverride?: string;
    initial?: boolean;
}
