/// <reference types="node" />
import http = require("http");
export declare function writeJsonDebug(res: http.ServerResponse, object: any): void;
export declare function writeJson(res: http.ServerResponse, object: any): void;
export declare function writeError(res: http.ServerResponse, errorMsg: string): void;
export declare function wait(ms: number): Promise<undefined>;
export declare function getFileContents(filePath: string): Promise<Buffer>;
export declare function isProcessRunning(name: string): Promise<boolean>;
export declare enum PluginInstallResult {
    Success = 0,
    Failure = 1,
    PromptRestartStudio = 2,
    AlreadyInstalled = 3
}
/**
 * attempts to automatically install the Rofresh Roblox Studio plugin
 */
export declare function installPlugin(installDir?: string): Promise<PluginInstallResult.Success | PluginInstallResult.Failure | PluginInstallResult.PromptRestartStudio>;
