"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const io_ts = require("io-ts");
exports.PartitionIO = io_ts.interface({
    path: io_ts.string,
    target: io_ts.string,
});
exports.RofreshConfigIO = io_ts.intersection([
    io_ts.interface({
        name: io_ts.string,
    }),
    io_ts.partial({
        allowAnyPlaceId: io_ts.boolean,
        partitions: io_ts.dictionary(io_ts.string, exports.PartitionIO),
        placeIds: io_ts.array(io_ts.number),
    }),
]);
//# sourceMappingURL=types.js.map