/// <reference types="node" />
export default class Language {
    name: string;
    ext: string;
    getSource: (filePath: string) => Promise<Buffer>;
    private static readonly _instances;
    static readonly instances: ReadonlyArray<Language>;
    static ignoreRegExp: RegExp;
    constructor(name: string, ext: string, getSource?: (filePath: string) => Promise<Buffer>);
    remove(): void;
}
