import { Change } from "../types";
import Project from "./Project";
export default class Partition {
    readonly project: Project;
    readonly name: string;
    readonly directory: string;
    readonly target: string;
    private isRunning;
    private watcher?;
    private rbxPath;
    private isSingleFile;
    private isSingleFileSet;
    constructor(project: Project, name: string, directory: string, target: string);
    private setSingleFile;
    addChangesRecursive(changes?: Promise<Change>[], dir?: string): Promise<void>;
    private getUpdateFromFile;
    private getRemoveFromFile;
    private getChangeFromFile;
    syncChangeToStudio(filePath: string): Promise<void>;
    syncRemoveToStudio(filePath: string): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
}
